package de.intevation.flys.artifacts.model.minfo;

import org.apache.log4j.Logger;

import de.intevation.artifactdatabase.state.Facet;
import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.CallContext;
import de.intevation.flys.artifacts.FLYSArtifact;
import de.intevation.flys.artifacts.model.CalculationResult;
import de.intevation.flys.artifacts.model.DataFacet;
import de.intevation.flys.artifacts.states.DefaultState.ComputeType;


public class BedDiffYearFacet
extends DataFacet
{
    private static Logger logger = Logger.getLogger(BedDiffYearFacet.class);

    public BedDiffYearFacet() {
    }

    public BedDiffYearFacet(int idx, String name, String description,
        ComputeType type, String stateId, String hash) {
        super(idx, name, description, type, hash, stateId);
    }

    public Object getData(Artifact artifact, CallContext context) {
        logger.debug("Get data for bed density at index: " + index);

        FLYSArtifact flys = (FLYSArtifact) artifact;

        CalculationResult res = (CalculationResult) flys.compute(context, hash,
            stateId, type, false);

        BedDiffYearResult[] data =
            (BedDiffYearResult[]) res.getData(); // TODO CAST TO SPECIFIC CLASS

        return data != null && data.length > index ? data[index] : null;
    }

    /** Copy deeply. */
    @Override
    public Facet deepCopy() {
        BedDiffYearFacet copy = new BedDiffYearFacet();
        copy.set(this);
        copy.type = type;
        copy.hash = hash;
        copy.stateId = stateId;
        return copy;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
